    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * LineNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2005, by the Australian Antarctic Division and
    031     *                           Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: LineNeedle.java,v 1.4.2.2 2005/10/25 20:50:49 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.Shape;
    051    import java.awt.geom.Line2D;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle that is represented by a line.
    058     *
    059     * @author Bryan Scott
    060     */
    061    public class LineNeedle extends MeterNeedle
    062                            implements Cloneable, Serializable {
    063
    064        /** For serialization. */
    065        private static final long serialVersionUID = 6215321387896748945L;
    066
    067        /**
    068         * Draws the needle.
    069         *
    070         * @param g2  the graphics device.
    071         * @param plotArea  the plot area.
    072         * @param rotate  the rotation point.
    073         * @param angle  the angle.
    074         */
    075        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    076                                  Point2D rotate, double angle) {
    077
    078            Line2D shape = new Line2D.Double();
    079
    080            double x = plotArea.getMinX() + (plotArea.getWidth() / 2);
    081            shape.setLine(x, plotArea.getMinY(), x, plotArea.getMaxY());
    082
    083            Shape s = shape;
    084
    085            if ((rotate != null) && (angle != 0)) {
    086                /// we have rotation
    087                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    088                s = getTransform().createTransformedShape(s);
    089            }
    090
    091            defaultDisplay(g2, s);
    092
    093        }
    094
    095        /**
    096         * Tests another object for equality with this object.
    097         *
    098         * @param obj  the object to test (<code>null</code> permitted).
    099         *
    100         * @return A boolean.
    101         */
    102        public boolean equals(Object obj) {
    103            if (obj == this) {
    104                return true;
    105            }
    106            if (!(obj instanceof LineNeedle)) {
    107                return false;
    108            }
    109            if (!super.equals(obj)) {
    110                return false;
    111            }
    112            return true;
    113        }
    114
    115        /**
    116         * Returns a clone of this needle.
    117         *
    118         * @return A clone.
    119         */
    120        public Object clone() throws CloneNotSupportedException {
    121            return super.clone();
    122        }
    123
    124    }
    125